Index: trunk/MagicSoft/TDAS-Extractor/PedestalSpectrum-28-Run38993.eps
===================================================================
--- trunk/MagicSoft/TDAS-Extractor/PedestalSpectrum-28-Run38993.eps	(revision 6371)
+++ trunk/MagicSoft/TDAS-Extractor/PedestalSpectrum-28-Run38993.eps	(revision 6400)
@@ -3,5 +3,5 @@
 %%Title: ./ped_plots/PedestalSpectrum-28-Run38993.eps: Pedestals
 %%Creator: ROOT Version 3.10/02
-%%CreationDate: Fri Feb 11 02:40:18 2005
+%%CreationDate: Sat Feb 12 06:52:07 2005
 %%EndComments
 %%BeginProlog
@@ -133,20 +133,20 @@
  t 0 r 0 0 m /Helvetica-Bold findfont 60.8783 sf 0 0 m (phe) show  gr 
  gsave  871 2096
- t 0 r 0 0 m /Helvetica-Bold findfont 91.3174 sf 0 0 m (Signal [N) show  gr  337 1907 m 52 Y s 405 1933 m 26 Y s 474 1933 m 26 Y s 543 1933 m 26 Y s 612 1907 m 52 Y s 680 1933 m 26 Y s 749 1933 m 26 Y s 818 1933 m 26 Y s 886 1907 m 52 Y s 955 1933 m
- 26 Y s 1024 1933 m 26 Y s 1093 1933 m 26 Y s 1161 1907 m 52 Y s 1230 1933 m 26 Y s 1299 1933 m 26 Y s 1368 1933 m 26 Y s 1436 1907 m 52 Y s 1505 1933 m 26 Y s 1574 1933 m 26 Y s 1642 1933 m 26 Y s 1711 1907 m 52 Y s 1780 1933 m 26 Y s 1849 1933 m 26
- Y s 1917 1933 m 26 Y s 1986 1907 m 52 Y s 337 1907 m 52 Y s 268 1933 m 26 Y s 1986 1907 m 52 Y s
- gsave  312 1975
+ t 0 r 0 0 m /Helvetica-Bold findfont 91.3174 sf 0 0 m (Signal [N) show  gr  379 1907 m 52 Y s 442 1933 m 26 Y s 506 1933 m 26 Y s 569 1933 m 26 Y s 633 1907 m 52 Y s 696 1933 m 26 Y s 760 1933 m 26 Y s 823 1933 m 26 Y s 886 1907 m 52 Y s 950 1933 m
+ 26 Y s 1013 1933 m 26 Y s 1077 1933 m 26 Y s 1140 1907 m 52 Y s 1204 1933 m 26 Y s 1267 1933 m 26 Y s 1330 1933 m 26 Y s 1394 1907 m 52 Y s 1457 1933 m 26 Y s 1521 1933 m 26 Y s 1584 1933 m 26 Y s 1648 1907 m 52 Y s 1711 1933 m 26 Y s 1775 1933 m 26
+ Y s 1838 1933 m 26 Y s 1901 1907 m 52 Y s 379 1907 m 52 Y s 316 1933 m 26 Y s 252 1933 m 26 Y s 1901 1907 m 52 Y s 1965 1933 m 26 Y s 2028 1933 m 26 Y s
+ gsave  354 1975
  t 0 r 0 0 m /Helvetica-Bold findfont 49.4636 sf 0 0 m (-4) show  gr 
- gsave  586 1975
+ gsave  609 1975
  t 0 r 0 0 m /Helvetica-Bold findfont 49.4636 sf 0 0 m (-2) show  gr 
  gsave  868 1975
  t 0 r 0 0 m /Helvetica-Bold findfont 49.4636 sf 0 0 m (0) show  gr 
- gsave  1145 1975
+ gsave  1122 1975
  t 0 r 0 0 m /Helvetica-Bold findfont 49.4636 sf 0 0 m (2) show  gr 
- gsave  1419 1975
+ gsave  1377 1975
  t 0 r 0 0 m /Helvetica-Bold findfont 49.4636 sf 0 0 m (4) show  gr 
- gsave  1693 1975
+ gsave  1632 1975
  t 0 r 0 0 m /Helvetica-Bold findfont 49.4636 sf 0 0 m (6) show  gr 
- gsave  1967 1975
+ gsave  1883 1975
  t 0 r 0 0 m /Helvetica-Bold findfont 49.4636 sf 0 0 m (8) show  gr  1 0 0 c [12 15 4 15] 0 sd 9 lw black [] 0 sd 3 lw 1 0 0 c 1 lw << /PatternType 1 /PaintType 2 /TilingType 1 /BBox [ 0 0 100 100 ] /XStep 100 /YStep 100 /PaintProc { begin gsave
  0 0 m 100 100 l s gr end } >> [ 0.24 0 0 0.24 0 0 ] makepattern /P04 exch def /cs {[/Pattern /DeviceRGB] setcolorspace} def /FA {f [/DeviceRGB] setcolorspace} def cs 1 0 0 P04 setcolor 482 218 m 66 X 8 Y 17 X 9 Y 16 X -9 Y 33 X 9 Y 17 X 17 Y 16 X 70
@@ -158,8 +158,8 @@
  166 Y 16 X 95 Y 17 X 488 Y 16 X 226 Y 17 X 9 Y 16 X 148 Y 17 X -253 Y 16 X -287 Y 17 X 35 Y 16 X -313 Y 17 X -262 Y 16 X -43 Y 17 X -26 Y 16 X -52 Y 17 X -27 Y 16 X -26 Y 17 X 9 Y 16 X -17 Y 17 X FA 0 0 1 c [12 12] 0 sd 9 lw 746 218 m 17 X 34 Y 16 X
  96 Y 17 X 166 Y 16 X 95 Y 17 X 488 Y 16 X 226 Y 17 X 9 Y 16 X 148 Y 17 X -253 Y 16 X -287 Y 17 X 35 Y 16 X -313 Y 17 X -262 Y 16 X -43 Y 17 X -26 Y 16 X -52 Y 17 X -27 Y 16 X -26 Y 17 X 9 Y 16 X -17 Y 17 X s 0 1 0 c [] 0 sd black 3 lw 0 1 0 c 1 lw
- << /PatternType 1 /PaintType 2 /TilingType 1 /BBox [ 0 0 100 100 ] /XStep 100 /YStep 100 /PaintProc { begin gsave 50 0 m 50 100 l s gr end } >> [ 0.12 0 0 0.12 0 0 ] makepattern /P06 exch def cs 0 1 0 P06 setcolor 746 218 m 17 X 8 Y 16 X 35 Y 33 X
- 148 Y 17 X 105 Y 16 X 26 Y 17 X 235 Y 16 X -183 Y 17 X 235 Y 16 X 52 Y 17 X 166 Y 16 X 644 Y 17 X 17 Y 16 X -862 Y 17 X -208 Y 16 X -236 Y 17 X 105 Y 16 X -139 Y 17 X -53 Y 16 X -52 Y 17 X -35 Y 16 X -8 Y 17 X FA 0 1 0 c 9 lw 746 218 m 17 X 8 Y 16 X
- 35 Y 33 X 148 Y 17 X 105 Y 16 X 26 Y 17 X 235 Y 16 X -183 Y 17 X 235 Y 16 X 52 Y 17 X 166 Y 16 X 644 Y 17 X 17 Y 16 X -862 Y 17 X -208 Y 16 X -236 Y 17 X 105 Y 16 X -139 Y 17 X -53 Y 16 X -52 Y 17 X -35 Y 16 X -8 Y 17 X s black 3 lw 1 1 1 c 907 544
- 975 1306 bf black
+ << /PatternType 1 /PaintType 2 /TilingType 1 /BBox [ 0 0 100 100 ] /XStep 100 /YStep 100 /PaintProc { begin gsave 50 0 m 50 100 l s gr end } >> [ 0.12 0 0 0.12 0 0 ] makepattern /P06 exch def cs 0 1 0 P06 setcolor 746 218 m 17 X 17 Y 16 X 17 Y 17 X
+ 44 Y 16 X 157 Y 17 X 43 Y 16 X 70 Y 17 X 270 Y 16 X -227 Y 17 X 322 Y 16 X -17 Y 17 X 174 Y 16 X 523 Y 17 X -35 Y 16 X -792 Y 17 X -166 Y 16 X -218 Y 17 X 70 Y 16 X -113 Y 17 X -52 Y 16 X -53 Y 17 X -26 Y 16 X -8 Y 17 X FA 0 1 0 c 9 lw 746 218 m 17
+ X 17 Y 16 X 17 Y 17 X 44 Y 16 X 157 Y 17 X 43 Y 16 X 70 Y 17 X 270 Y 16 X -227 Y 17 X 322 Y 16 X -17 Y 17 X 174 Y 16 X 523 Y 17 X -35 Y 16 X -792 Y 17 X -166 Y 16 X -218 Y 17 X 70 Y 16 X -113 Y 17 X -52 Y 16 X -53 Y 17 X -26 Y 16 X -8 Y 17 X s black
+ 3 lw 1 1 1 c 907 544 975 1306 bf black
  gsave  997 1788
  t 0 r 0 0 m /Helvetica findfont 57.0734 sf 0 0 m (Digital Filter 6 slices \(Extractor #28\)) show  gr 
@@ -167,13 +167,13 @@
  t 0 r 0 0 m /Helvetica findfont 57.0734 sf 0 0 m (Fundamental \(offset.subtr.\)) show  gr  1 0 0 c [12 15 4 15] 0 sd 9 lw 1009 1733 m 159 X s black
  gsave  1199 1636
- t 0 r 0 0 m /Helvetica findfont 57.0734 sf 0 0 m (Mean: -0.05, RMS: 0.85 \(phe\)) show  gr  1 1 1 c [] 0 sd 3 lw 1009 1656 m 159 X s black
+ t 0 r 0 0 m /Helvetica findfont 57.0734 sf 0 0 m (Mean: -0.05, RMS: 0.93 \(phe\)) show  gr  1 1 1 c [] 0 sd 3 lw 1009 1656 m 159 X s black
  gsave  1199 1556
  t 0 r 0 0 m /Helvetica findfont 57.0734 sf 0 0 m (Fixed Window \(Random\)) show  gr  0 0 1 c [12 12] 0 sd 9 lw 1009 1578 m 159 X s black
  gsave  1199 1480
- t 0 r 0 0 m /Helvetica findfont 57.0734 sf 0 0 m (Mean: 0.00, RMS: 0.35 \(phe\)) show  gr  1 1 1 c [] 0 sd 3 lw 1009 1500 m 159 X s black
+ t 0 r 0 0 m /Helvetica findfont 57.0734 sf 0 0 m (Mean: 0.00, RMS: 0.38 \(phe\)) show  gr  1 1 1 c [] 0 sd 3 lw 1009 1500 m 159 X s black
  gsave  1199 1400
- t 0 r 0 0 m /Helvetica findfont 57.0734 sf 0 0 m (Sliding Win. \(12 sl. glob. win.\)) show  gr  0 1 0 c 9 lw 1009 1422 m 159 X s black
+ t 0 r 0 0 m /Helvetica findfont 57.0734 sf 0 0 m (Sliding Win. \(10 sl. glob. win.\)) show  gr  0 1 0 c 9 lw 1009 1422 m 159 X s black
  gsave  1199 1324
- t 0 r 0 0 m /Helvetica findfont 57.0734 sf 0 0 m (Mean: 0.39, RMS: 0.41 \(phe\)) show  gr  1 1 1 c 3 lw 1009 1345 m 159 X s
+ t 0 r 0 0 m /Helvetica findfont 57.0734 sf 0 0 m (Mean: 0.39, RMS: 0.45 \(phe\)) show  gr  1 1 1 c 3 lw 1009 1345 m 159 X s
  gr  gr 
 showpage